Agora Java API Reference for Android

Public Member Functions | List of all members
agora::rtc::IRtcEngineEventHandler Class Reference

`#include <IAgoraRtcEngine.h>`

Inheritance diagram for agora::rtc::IRtcEngineEventHandler:

## Public Member Functions
virtual const char * | eventHandlerType () const
virtual void | onJoinChannelSuccess (const char *channel, uid_t uid, int elapsed)
virtual void | onRejoinChannelSuccess (const char *channel, uid_t uid, int elapsed)
virtual void | onProxyConnected (const char *channel, uid_t uid, PROXY_TYPE proxyType, const char *localProxyIp, int elapsed)
virtual void | onError (int err, const char *msg)
virtual void | onAudioQuality (uid_t uid, int quality, unsigned short delay, unsigned short lost) __deprecated
virtual void | onLastmileProbeResult (const LastmileProbeResult &result)
virtual void | onAudioVolumeIndication (const AudioVolumeInfo *speakers, unsigned int speakerNumber, int totalVolume)
virtual void | onLeaveChannel (const RtcStats &stats)
virtual void | onRtcStats (const RtcStats &stats)
virtual void | onAudioDeviceStateChanged (const char *deviceId, int deviceType, int deviceState)
virtual void | onAudioMixingPositionChanged (int64_t position)
| Reports current AudioMixing progress. More...
virtual void | onAudioMixingFinished () __deprecated
virtual void | onAudioEffectFinished (int soundId)
virtual void | onVideoDeviceStateChanged (const char *deviceId, int deviceType, int deviceState)
virtual void | onNetworkQuality (uid_t uid, int txQuality, int rxQuality)
virtual void | onIntraRequestReceived ()
virtual void | onUplinkNetworkInfoUpdated (const UplinkNetworkInfo &info)
virtual void | onDownlinkNetworkInfoUpdated (const DownlinkNetworkInfo &info)
virtual void | onLastmileQuality (int quality)
virtual void | onFirstLocalVideoFrame (VIDEO_SOURCE_TYPE source, int width, int height, int elapsed)
virtual void | onFirstLocalVideoFramePublished (VIDEO_SOURCE_TYPE source, int elapsed)
virtual void | onFirstRemoteVideoDecoded (uid_t uid, int width, int height, int elapsed) __deprecated
virtual void | onVideoSizeChanged (VIDEO_SOURCE_TYPE sourceType, uid_t uid, int width, int height, int rotation)
virtual void | onLocalVideoStateChanged (VIDEO_SOURCE_TYPE source, LOCAL_VIDEO_STREAM_STATE state, LOCAL_VIDEO_STREAM_REASON reason)
virtual void | onRemoteVideoStateChanged (uid_t uid, REMOTE_VIDEO_STATE state, REMOTE_VIDEO_STATE_REASON reason, int elapsed)
virtual void | onFirstRemoteVideoFrame (uid_t uid, int width, int height, int elapsed)
virtual void | onUserJoined (uid_t uid, int elapsed)
virtual void | onUserOffline (uid_t uid, USER_OFFLINE_REASON_TYPE reason)
virtual void | onUserMuteAudio (uid_t uid, bool muted)
virtual void | onUserMuteVideo (uid_t uid, bool muted)
virtual void | onUserEnableVideo (uid_t uid, bool enabled)
virtual void | onUserStateChanged (uid_t uid, REMOTE_USER_STATE state)
virtual void | onUserEnableLocalVideo (uid_t uid, bool enabled) __deprecated
virtual void | onRemoteAudioStats (const RemoteAudioStats &stats)
virtual void | onLocalAudioStats (const LocalAudioStats &stats)
virtual void | onLocalVideoStats (VIDEO_SOURCE_TYPE source, const LocalVideoStats &stats)
virtual void | onRemoteVideoStats (const RemoteVideoStats &stats)
virtual void | onCameraReady () __deprecated
virtual void | onCameraFocusAreaChanged (int x, int y, int width, int height)
virtual void | onCameraExposureAreaChanged (int x, int y, int width, int height)
virtual void | onVideoStopped () __deprecated
virtual void | onAudioMixingStateChanged (AUDIO_MIXING_STATE_TYPE state, AUDIO_MIXING_REASON_TYPE reason)
virtual void | onRhythmPlayerStateChanged (RHYTHM_PLAYER_STATE_TYPE state, RHYTHM_PLAYER_REASON reason)
virtual void | onConnectionLost ()
virtual void | onConnectionInterrupted () __deprecated
virtual void | onConnectionBanned () __deprecated
virtual void | onStreamMessage (uid_t uid, int streamId, const char *data, size_t length, uint64_t sentTs)
virtual void | onStreamMessageError (uid_t uid, int streamId, int code, int missed, int cached)
virtual void | onRequestToken ()
virtual void | onTokenPrivilegeWillExpire (const char *token)
virtual void | onLicenseValidationFailure (LICENSE_ERROR_TYPE error)
virtual void | onFirstLocalAudioFramePublished (int elapsed)
virtual void | onFirstRemoteAudioDecoded (uid_t uid, int elapsed) __deprecated
virtual void | onFirstRemoteAudioFrame (uid_t uid, int elapsed) __deprecated
virtual void | onLocalAudioStateChanged (LOCAL_AUDIO_STREAM_STATE state, LOCAL_AUDIO_STREAM_REASON reason)
virtual void | onRemoteAudioStateChanged (uid_t uid, REMOTE_AUDIO_STATE state, REMOTE_AUDIO_STATE_REASON reason, int elapsed)
virtual void | onActiveSpeaker (uid_t uid)
virtual void | onContentInspectResult (media::CONTENT_INSPECT_RESULT result)
virtual void | onSnapshotTaken (uid_t uid, const char *filePath, int width, int height, int errCode)
virtual void | onClientRoleChanged (CLIENT_ROLE_TYPE oldRole, CLIENT_ROLE_TYPE newRole, const ClientRoleOptions &newRoleOptions)
virtual void | onClientRoleChangeFailed (CLIENT_ROLE_CHANGE_FAILED_REASON reason, CLIENT_ROLE_TYPE currentRole)
virtual void | onAudioDeviceVolumeChanged (MEDIA_DEVICE_TYPE deviceType, int volume, bool muted)
virtual void | onRtmpStreamingStateChanged (const char *url, RTMP_STREAM_PUBLISH_STATE state, RTMP_STREAM_PUBLISH_REASON reason)
virtual void | onRtmpStreamingEvent (const char *url, RTMP_STREAMING_EVENT eventCode)
virtual void | onTranscodingUpdated ()
virtual void | onAudioRoutingChanged (int routing)
virtual void | onChannelMediaRelayStateChanged (int state, int code)
virtual void | onLocalPublishFallbackToAudioOnly (bool isFallbackOrRecover)
virtual void | onRemoteSubscribeFallbackToAudioOnly (uid_t uid, bool isFallbackOrRecover)
virtual void | onRemoteAudioTransportStats (uid_t uid, unsigned short delay, unsigned short lost, unsigned short rxKBitRate) __deprecated
virtual void | onRemoteVideoTransportStats (uid_t uid, unsigned short delay, unsigned short lost, unsigned short rxKBitRate) __deprecated
virtual void | onConnectionStateChanged (CONNECTION_STATE_TYPE state, CONNECTION_CHANGED_REASON_TYPE reason)
virtual void | onWlAccMessage (WLACC_MESSAGE_REASON reason, WLACC_SUGGEST_ACTION action, const char *wlAccMsg)
virtual void | onWlAccStats (const WlAccStats &currentStats, const WlAccStats &averageStats)
virtual void | onNetworkTypeChanged (NETWORK_TYPE type)
virtual void | onEncryptionError (ENCRYPTION_ERROR_TYPE errorType)
virtual void | onPermissionError (PERMISSION_TYPE permissionType)
virtual void | onLocalUserRegistered (uid_t uid, const char *userAccount)
virtual void | onUserInfoUpdated (uid_t uid, const UserInfo &info)
virtual void | onUserAccountUpdated (uid_t uid, const char *userAccount)
virtual void | onVideoRenderingTracingResult (uid_t uid, MEDIA_TRACE_EVENT currentEvent, VideoRenderingTracingInfo tracingInfo)
virtual void | onLocalVideoTranscoderError (const TranscodingVideoStream &stream, VIDEO_TRANSCODER_ERROR error)
virtual void | onUploadLogResult (const char *requestId, bool success, UPLOAD_ERROR_REASON reason)
virtual void | onAudioSubscribeStateChanged (const char *channel, uid_t uid, STREAM_SUBSCRIBE_STATE oldState, STREAM_SUBSCRIBE_STATE newState, int elapseSinceLastState)
virtual void | onVideoSubscribeStateChanged (const char *channel, uid_t uid, STREAM_SUBSCRIBE_STATE oldState, STREAM_SUBSCRIBE_STATE newState, int elapseSinceLastState)
virtual void | onAudioPublishStateChanged (const char *channel, STREAM_PUBLISH_STATE oldState, STREAM_PUBLISH_STATE newState, int elapseSinceLastState)
virtual void | onVideoPublishStateChanged (VIDEO_SOURCE_TYPE source, const char *channel, STREAM_PUBLISH_STATE oldState, STREAM_PUBLISH_STATE newState, int elapseSinceLastState)
virtual void | onTranscodedStreamLayoutInfo (uid_t uid, int width, int height, int layoutCount, const VideoLayout *layoutlist)
virtual void | onAudioMetadataReceived (uid_t uid, const char *metadata, size_t length)
virtual void | onExtensionEventWithContext (const ExtensionContext &context, const char *key, const char *value)
virtual void | onExtensionStartedWithContext (const ExtensionContext &context)
virtual void | onExtensionStoppedWithContext (const ExtensionContext &context)
virtual void | onExtensionErrorWithContext (const ExtensionContext &context, int error, const char *message)
virtual void | onSetRtmFlagResult (int code)

## Detailed Description

The IRtcEngineEventHandler class.

The SDK uses this class to send callback event notifications to the app, and the app inherits the methods in this class to retrieve these event notifications.

All methods in this class have their default (empty) implementations, and the app can inherit only some of the required events instead of all. In the callback methods, the app should avoid time-consuming tasks or calling blocking APIs, otherwise the SDK may not work properly.

## Member Function Documentation

## ◆ onJoinChannelSuccess()

virtual void agora::rtc::IRtcEngineEventHandler::onJoinChannelSuccess | ( | const char * | channel,
|  | uid_t | uid,
|  | int | elapsed
| ) |  |
| virtual

Occurs when a user joins a channel.

This callback notifies the application that a user joins a specified channel.

Parameters

  channel | The channel name.
  uid | The ID of the user who joins the channel.
  elapsed | The time elapsed (ms) from the local user calling joinChannel until the SDK triggers this callback.

## ◆ onRejoinChannelSuccess()

virtual void agora::rtc::IRtcEngineEventHandler::onRejoinChannelSuccess | ( | const char * | channel,
|  | uid_t | uid,
|  | int | elapsed
| ) |  |
| virtual

Occurs when a user rejoins the channel.

When a user loses connection with the server because of network problems, the SDK automatically tries to reconnect and triggers this callback upon reconnection.

Parameters

  channel | The channel name.
  uid | The ID of the user who rejoins the channel.
  elapsed | Time elapsed (ms) from the local user calling the joinChannel method until this callback is triggered.

## ◆ onProxyConnected()

virtual void agora::rtc::IRtcEngineEventHandler::onProxyConnected | ( | const char * | channel,
|  | uid_t | uid,
|  | PROXY_TYPE | proxyType,
|  | const char * | localProxyIp,
|  | int | elapsed
| ) |  |
| virtual

Occurs when join success after calling setLocalAccessPoint or setCloudProxy

Parameters

  channel | Channel name.
  uid | User ID of the user joining the channel.
  proxyType | type of proxy agora sdk connected, proxyType will be NONE_PROXY_TYPE if not connected to proxy(fallback).
  localProxyIp | local proxy ip. if not join local proxy, it will be "".
  elapsed | Time elapsed (ms) from the user calling the joinChannel method until the SDK triggers this callback.

## ◆ onError()

virtual void agora::rtc::IRtcEngineEventHandler::onError | ( | int | err,
|  | const char * | msg
| ) |  |
| virtual

An error occurs during the SDK runtime.

Parameters

  err | The error code: #ERROR_CODE_TYPE.
  msg | The detailed error message.

## ◆ onAudioQuality()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioQuality | ( | uid_t | uid,
|  | int | quality,
|  | unsigned short | delay,
|  | unsigned short | lost
| ) |  |
| virtual

Reports the statistics of the audio stream from each remote user/broadcaster.

Deprecated:
  This callback is deprecated. Use onRemoteAudioStats instead.

The SDK triggers this callback once every two seconds to report the audio quality of each remote user/host sending an audio stream. If a channel has multiple remote users/hosts sending audio streams, the SDK triggers this callback as many times.

Parameters

  uid | The user ID of the remote user sending the audio stream.
  quality | The audio quality of the user: #QUALITY_TYPE
  delay | The network delay (ms) from the sender to the receiver, including the delay caused by audio sampling pre-processing, network transmission, and network jitter buffering.
  lost | The audio packet loss rate (%) from the sender to the receiver.

## ◆ onLastmileProbeResult()

virtual void agora::rtc::IRtcEngineEventHandler::onLastmileProbeResult | ( | const LastmileProbeResult & | result | ) |
| virtual

Reports the result of the last-mile network probe result.

The SDK triggers this callback within 30 seconds after the app calls the `startLastmileProbeTest` method.

Parameters

  result | The uplink and downlink last-mile network probe test result: LastmileProbeResult.

## ◆ onAudioVolumeIndication()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioVolumeIndication | ( | const AudioVolumeInfo * | speakers,
|  | unsigned int | speakerNumber,
|  | int | totalVolume
| ) |  |
| virtual

Reports the volume information of users.

By default, this callback is disabled. You can enable it by calling `enableAudioVolumeIndication`. Once this callback is enabled and users send streams in the channel, the SDK triggers the `onAudioVolumeIndication` callback at the time interval set in `enableAudioVolumeIndication`. The SDK triggers two independent `onAudioVolumeIndication` callbacks simultaneously, which separately report the volume information of the local user who sends a stream and the remote users (up to three) whose instantaneous volume is the highest.

Note
  After you enable this callback, calling muteLocalAudioStream affects the SDK's behavior as follows:
  - If the local user stops publishing the audio stream, the SDK stops triggering the local user's callback.
  - 20 seconds after a remote user whose volume is one of the three highest stops publishing the audio stream, the callback excludes this user's information; 20 seconds after all remote users stop publishing audio streams, the SDK stops triggering the callback for remote users.

Parameters

  speakers | The volume information of the users, see AudioVolumeInfo. An empty `speakers` array in the callback indicates that no remote user is in the channel or sending a stream at the moment.
  speakerNumber | The total number of speakers. In the local user's callback, when the local user sends a stream, `speakerNumber` is 1. In the callback for remote users, the value range of speakerNumber is [0,3]. If the number of remote users who send streams is greater than or equal to three, the value of `speakerNumber` is 3.
  totalVolume | The volume of the speaker. The value ranges between 0 (lowest volume) and 255 (highest volume). In the local user's callback, `totalVolume` is the volume of the local user who sends a stream. In the remote users' callback, `totalVolume` is the sum of all remote users (up to three) whose instantaneous volume is the highest. If the user calls `startAudioMixing`, `totalVolume` is the volume after audio mixing.

## ◆ onLeaveChannel()

virtual void agora::rtc::IRtcEngineEventHandler::onLeaveChannel | ( | const RtcStats & | stats | ) |
| virtual

Occurs when a user leaves a channel.

This callback notifies the app that the user leaves the channel by calling `leaveChannel`. From this callback, the app can get information such as the call duration and quality statistics.

Parameters

  stats | The statistics on the call: RtcStats.

## ◆ onRtcStats()

virtual void agora::rtc::IRtcEngineEventHandler::onRtcStats | ( | const RtcStats & | stats | ) |
| virtual

Reports the statistics of the current call.

The SDK triggers this callback once every two seconds after the user joins the channel.

Parameters

  stats | The statistics of the current call: RtcStats.

## ◆ onAudioDeviceStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioDeviceStateChanged | ( | const char * | deviceId,
|  | int | deviceType,
|  | int | deviceState
| ) |  |
| virtual

Occurs when the audio device state changes.

This callback notifies the application that the system's audio device state is changed. For example, a headset is unplugged from the device.

Parameters

  deviceId | The device ID.
  deviceType | The device type: #MEDIA_DEVICE_TYPE.
  deviceState | The device state: On macOS: 0: The device is ready for use. 8: The device is not connected. On Windows: #MEDIA_DEVICE_STATE_TYPE.

## ◆ onAudioMixingPositionChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioMixingPositionChanged | ( | int64_t | position | ) |
| virtual

Reports current AudioMixing progress.

The callback occurs once every one second during the playback and reports the current playback progress.

Parameters

  position | Current AudioMixing progress (millisecond).

## ◆ onAudioMixingFinished()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioMixingFinished | ( |  | ) |
| virtual

Occurs when the audio mixing file playback finishes.

Deprecated:
  This method is deprecated, use onAudioMixingStateChanged instead.

After you call startAudioMixing to play a local music file, this callback occurs when the playback finishes. If the startAudioMixing method call fails, the SDK returns the error code 701.

## ◆ onAudioEffectFinished()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioEffectFinished | ( | int | soundId | ) |
| virtual

Occurs when the playback of the local audio effect file finishes.

This callback occurs when the local audio effect file finishes playing.

Parameters

  soundId | The audio effect ID. The ID of each audio effect file is unique.

## ◆ onVideoDeviceStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onVideoDeviceStateChanged | ( | const char * | deviceId,
|  | int | deviceType,
|  | int | deviceState
| ) |  |
| virtual

Occurs when the video device state changes.

This callback notifies the application that the system's video device state is changed.

Parameters

  deviceId | Pointer to the device ID.
  deviceType | Device type: #MEDIA_DEVICE_TYPE.
  deviceState | Device state: #MEDIA_DEVICE_STATE_TYPE.

## ◆ onNetworkQuality()

virtual void agora::rtc::IRtcEngineEventHandler::onNetworkQuality | ( | uid_t | uid,
|  | int | txQuality,
|  | int | rxQuality
| ) |  |
| virtual

Reports the last mile network quality of each user in the channel.

This callback reports the last mile network conditions of each user in the channel. Last mile refers to the connection between the local device and Agora's edge server.

The SDK triggers this callback once every two seconds. If a channel includes multiple users, the SDK triggers this callback as many times.

Note
  `txQuality` is UNKNOWN when the user is not sending a stream; `rxQuality` is UNKNOWN when the user is not receiving a stream.

Parameters

  uid | The user ID. The network quality of the user with this user ID is reported.
  txQuality | Uplink network quality rating of the user in terms of the transmission bit rate, packet loss rate, average RTT (Round-Trip Time) and jitter of the uplink network. This parameter is a quality rating helping you understand how well the current uplink network conditions can support the selected video encoder configuration. For example, a 1000 Kbps uplink network may be adequate for video frames with a resolution of 640 × 480 and a frame rate of 15 fps in the LIVE_BROADCASTING profile, but may be inadequate for resolutions higher than 1280 × 720. See #QUALITY_TYPE.
  rxQuality | Downlink network quality rating of the user in terms of packet loss rate, average RTT, and jitter of the downlink network. See #QUALITY_TYPE.

## ◆ onIntraRequestReceived()

virtual void agora::rtc::IRtcEngineEventHandler::onIntraRequestReceived | ( |  | ) |
| virtual

Occurs when intra request from remote user is received.

This callback is triggered once remote user needs one Key frame.

## ◆ onUplinkNetworkInfoUpdated()

virtual void agora::rtc::IRtcEngineEventHandler::onUplinkNetworkInfoUpdated | ( | const UplinkNetworkInfo & | info | ) |
| virtual

Occurs when uplink network info is updated.

The SDK triggers this callback when the uplink network information changes.

Note
  This callback only applies to scenarios where you push externally encoded video data in H.264 format to the SDK.

Parameters

  info | The uplink network information. See UplinkNetworkInfo.

## ◆ onDownlinkNetworkInfoUpdated()

virtual void agora::rtc::IRtcEngineEventHandler::onDownlinkNetworkInfoUpdated | ( | const DownlinkNetworkInfo & | info | ) |
| virtual

Occurs when downlink network info is updated.

This callback is used for notifying user to switch major/minor stream if needed.

Parameters

  info | The downlink network info collections.

## ◆ onLastmileQuality()

virtual void agora::rtc::IRtcEngineEventHandler::onLastmileQuality | ( | int | quality | ) |
| virtual

Reports the last-mile network quality of the local user.

This callback reports the last-mile network conditions of the local user before the user joins the channel. Last mile refers to the connection between the local device and Agora's edge server.

When the user is not in a channel and the last-mile network test is enabled (by calling `startLastmileProbeTest`), this callback function is triggered to update the app on the network connection quality of the local user.

Parameters

  quality | The last mile network quality. See #QUALITY_TYPE.

## ◆ onFirstLocalVideoFrame()

virtual void agora::rtc::IRtcEngineEventHandler::onFirstLocalVideoFrame | ( | VIDEO_SOURCE_TYPE | source,
|  | int | width,
|  | int | height,
|  | int | elapsed
| ) |  |
| virtual

Occurs when the first local video frame is rendered on the local video view.

Parameters

  source | The video source: #VIDEO_SOURCE_TYPE.
  width | The width (px) of the first local video frame.
  height | The height (px) of the first local video frame.
  elapsed | Time elapsed (ms) from the local user calling the `joinChannel` method until the SDK triggers this callback. If you call the `startPreview` method before calling the `joinChannel` method, then `elapsed` is the time elapsed from calling the `startPreview` method until the SDK triggers this callback.

## ◆ onFirstLocalVideoFramePublished()

virtual void agora::rtc::IRtcEngineEventHandler::onFirstLocalVideoFramePublished | ( | VIDEO_SOURCE_TYPE | source,
|  | int | elapsed
| ) |  |
| virtual

Occurs when the first local video frame is published. The SDK triggers this callback under one of the following circumstances:

- The local client enables the video module and calls `joinChannel` successfully.
- The local client calls `muteLocalVideoStream(true)` and muteLocalVideoStream(false) in sequence.
- The local client calls `disableVideo` and `enableVideo` in sequence.
- The local client calls `pushVideoFrame` to successfully push the video frame to the SDK.
  Parameters

    source | The video source type.
    elapsed | The time elapsed (ms) from the local user calling joinChannel` to the SDK triggers this callback.

## ◆ onFirstRemoteVideoDecoded()

virtual void agora::rtc::IRtcEngineEventHandler::onFirstRemoteVideoDecoded | ( | uid_t | uid,
|  | int | width,
|  | int | height,
|  | int | elapsed
| ) |  |
| virtual

Occurs when the first remote video frame is received and decoded.

The SDK triggers this callback under one of the following circumstances:

- The remote user joins the channel and sends the video stream.
- The remote user stops sending the video stream and re-sends it after 15 seconds. Reasons for such an interruption include:
  - The remote user leaves the channel.
  - The remote user drops offline.
  - The remote user calls `muteLocalVideoStream` to stop sending the video stream.
  - The remote user calls `disableVideo` to disable video.

Parameters

  uid | The user ID of the remote user sending the video stream.
  width | The width (pixels) of the video stream.
  height | The height (pixels) of the video stream.
  elapsed | The time elapsed (ms) from the local user calling `joinChannel` until the SDK triggers this callback.

## ◆ onVideoSizeChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onVideoSizeChanged | ( | VIDEO_SOURCE_TYPE | sourceType,
|  | uid_t | uid,
|  | int | width,
|  | int | height,
|  | int | rotation
| ) |  |
| virtual

Occurs when the local or remote video size or rotation has changed.

Parameters

  sourceType | The video source type: #VIDEO_SOURCE_TYPE.
  uid | The user ID. 0 indicates the local user.
  width | The new width (pixels) of the video.
  height | The new height (pixels) of the video.
  rotation | The rotation information of the video.

## ◆ onLocalVideoStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onLocalVideoStateChanged | ( | VIDEO_SOURCE_TYPE | source,
|  | LOCAL_VIDEO_STREAM_STATE | state,
|  | LOCAL_VIDEO_STREAM_REASON | reason
| ) |  |
| virtual

Occurs when the local video stream state changes.

When the state of the local video stream changes (including the state of the video capture and encoding), the SDK triggers this callback to report the current state. This callback indicates the state of the local video stream, including camera capturing and video encoding, and allows you to troubleshoot issues when exceptions occur.

The SDK triggers the onLocalVideoStateChanged callback with the state code of `LOCAL_VIDEO_STREAM_STATE_FAILED` and error code of `LOCAL_VIDEO_STREAM_REASON_CAPTURE_FAILURE` in the following situations:

- The app switches to the background, and the system gets the camera resource.
- The camera starts normally, but does not output video for four consecutive seconds.

When the camera outputs the captured video frames, if the video frames are the same for 15 consecutive frames, the SDK triggers the `onLocalVideoStateChanged` callback with the state code of `LOCAL_VIDEO_STREAM_STATE_CAPTURING` and error code of `LOCAL_VIDEO_STREAM_REASON_CAPTURE_FAILURE`. Note that the video frame duplication detection is only available for video frames with a resolution greater than 200 × 200, a frame rate greater than or equal to 10 fps, and a bitrate less than 20 Kbps.

Note
  For some device models, the SDK does not trigger this callback when the state of the local video changes while the local video capturing device is in use, so you have to make your own timeout judgment.

Parameters

  source | The video source type: #VIDEO_SOURCE_TYPE.
  state | The state of the local video. See #LOCAL_VIDEO_STREAM_STATE.
  reason | The detailed error information. See #LOCAL_VIDEO_STREAM_REASON.

## ◆ onRemoteVideoStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onRemoteVideoStateChanged | ( | uid_t | uid,
|  | REMOTE_VIDEO_STATE | state,
|  | REMOTE_VIDEO_STATE_REASON | reason,
|  | int | elapsed
| ) |  |
| virtual

Occurs when the remote video state changes.

Note
  This callback does not work properly when the number of users (in the voice/video call channel) or hosts (in the live streaming channel) in the channel exceeds 17.

Parameters

  uid | The ID of the user whose video state has changed.
  state | The remote video state: #REMOTE_VIDEO_STATE.
  reason | The reason of the remote video state change: #REMOTE_VIDEO_STATE_REASON.
  elapsed | The time elapsed (ms) from the local client calling `joinChannel` until this callback is triggered.

## ◆ onFirstRemoteVideoFrame()

virtual void agora::rtc::IRtcEngineEventHandler::onFirstRemoteVideoFrame | ( | uid_t | uid,
|  | int | width,
|  | int | height,
|  | int | elapsed
| ) |  |
| virtual

Occurs when the renderer receives the first frame of the remote video.

Parameters

  uid | The user ID of the remote user sending the video stream.
  width | The width (px) of the video frame.
  height | The height (px) of the video stream.
  elapsed | The time elapsed (ms) from the local user calling `joinChannel` until the SDK triggers this callback.

## ◆ onUserJoined()

virtual void agora::rtc::IRtcEngineEventHandler::onUserJoined | ( | uid_t | uid,
|  | int | elapsed
| ) |  |
| virtual

Occurs when a remote user or broadcaster joins the channel.

- In the COMMUNICATION channel profile, this callback indicates that a remote user joins the channel. The SDK also triggers this callback to report the existing users in the channel when a user joins the channel. In the LIVE_BROADCASTING channel profile, this callback indicates that a host joins the channel. The SDK also triggers this callback to report the existing hosts in the channel when a host joins the channel. Agora recommends limiting the number of hosts to 17.

The SDK triggers this callback under one of the following circumstances:

- A remote user/host joins the channel by calling the `joinChannel` method.
- A remote user switches the user role to the host after joining the channel.
- A remote user/host rejoins the channel after a network interruption.

Parameters

  uid | The ID of the remote user or broadcaster joining the channel.
  elapsed | The time elapsed (ms) from the local user calling `joinChannel` or `setClientRole` until this callback is triggered.

## ◆ onUserOffline()

virtual void agora::rtc::IRtcEngineEventHandler::onUserOffline | ( | uid_t | uid,
|  | USER_OFFLINE_REASON_TYPE | reason
| ) |  |
| virtual

Occurs when a remote user or broadcaster goes offline.

There are two reasons for a user to go offline:

- Leave the channel: When the user leaves the channel, the user sends a goodbye message. When this message is received, the SDK determines that the user leaves the channel.
- Drop offline: When no data packet of the user is received for a certain period of time, the SDK assumes that the user drops offline. A poor network connection may lead to false detection, so we recommend using the RTM SDK for reliable offline detection.
- The user switches the user role from a broadcaster to an audience.

Parameters

  uid | The ID of the remote user or broadcaster who leaves the channel or drops offline.
  reason | The reason why the remote user goes offline: #USER_OFFLINE_REASON_TYPE.

## ◆ onUserMuteAudio()

virtual void agora::rtc::IRtcEngineEventHandler::onUserMuteAudio | ( | uid_t | uid,
|  | bool | muted
| ) |  |
| virtual

Occurs when a remote user's audio stream playback pauses/resumes.

The SDK triggers this callback when the remote user stops or resumes sending the audio stream by calling the `muteLocalAudioStream` method.

Note
  This callback can be inaccurate when the number of users (in the `COMMUNICATION` profile) or hosts (in the `LIVE_BROADCASTING` profile) in the channel exceeds 17.

Parameters

  uid | The user ID.
  muted | Whether the remote user's audio stream is muted/unmuted: true: Muted. false: Unmuted.

## ◆ onUserMuteVideo()

virtual void agora::rtc::IRtcEngineEventHandler::onUserMuteVideo | ( | uid_t | uid,
|  | bool | muted
| ) |  |
| virtual

Occurs when a remote user pauses or resumes sending the video stream.

When a remote user calls `muteLocalVideoStream` to stop or resume publishing the video stream, the SDK triggers this callback to report the state of the remote user's publishing stream to the local user.

Note
  This callback is invalid when the number of users or broadacasters in a channel exceeds 20.

Parameters

  userId | ID of the remote user.
  muted | Whether the remote user stops publishing the video stream: true: The remote user has paused sending the video stream. false: The remote user has resumed sending the video stream.

## ◆ onUserEnableVideo()

virtual void agora::rtc::IRtcEngineEventHandler::onUserEnableVideo | ( | uid_t | uid,
|  | bool | enabled
| ) |  |
| virtual

Occurs when a remote user enables or disables the video module.

Once the video function is disabled, the users cannot see any video.

The SDK triggers this callback when a remote user enables or disables the video module by calling the `enableVideo` or `disableVideo` method.

Parameters

  uid | The ID of the remote user.
  enabled | Whether the video of the remote user is enabled: true: The remote user has enabled video. false: The remote user has disabled video.

## ◆ onUserStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onUserStateChanged | ( | uid_t | uid,
|  | REMOTE_USER_STATE | state
| ) |  |
| virtual

Occurs when the remote user audio or video state is updated.

Parameters

  uid | The uid of the remote user.
  state | The remote user's audio or video state: #REMOTE_USER_STATE.

## ◆ onUserEnableLocalVideo()

virtual void agora::rtc::IRtcEngineEventHandler::onUserEnableLocalVideo | ( | uid_t | uid,
|  | bool | enabled
| ) |  |
| virtual

Occurs when a remote user enables or disables local video capturing.

The SDK triggers this callback when the remote user resumes or stops capturing the video stream by calling the `enableLocalVideo` method.

Parameters

  uid | The ID of the remote user.
  enabled | Whether the specified remote user enables/disables local video: `true`: The remote user has enabled local video capturing. `false`: The remote user has disabled local video capturing.

## ◆ onRemoteAudioStats()

virtual void agora::rtc::IRtcEngineEventHandler::onRemoteAudioStats | ( | const RemoteAudioStats & | stats | ) |
| virtual

Reports the statistics of the audio stream from each remote user/host.

The SDK triggers this callback once every two seconds for each remote user who is sending audio streams. If a channel includes multiple remote users, the SDK triggers this callback as many times.

Parameters

  stats | Statistics of the received remote audio streams. See RemoteAudioStats.

## ◆ onLocalAudioStats()

virtual void agora::rtc::IRtcEngineEventHandler::onLocalAudioStats | ( | const LocalAudioStats & | stats | ) |
| virtual

Reports the statistics of the local audio stream.

The SDK triggers this callback once every two seconds.

Parameters

  stats | The statistics of the local audio stream. See LocalAudioStats.

## ◆ onLocalVideoStats()

virtual void agora::rtc::IRtcEngineEventHandler::onLocalVideoStats | ( | VIDEO_SOURCE_TYPE | source,
|  | const LocalVideoStats & | stats
| ) |  |
| virtual

Reports the statistics of the local video stream.

The SDK triggers this callback once every two seconds for each user/host. If there are multiple users/hosts in the channel, the SDK triggers this callback as many times.

Note
  If you have called the `enableDualStreamMode` method, this callback reports the statistics of the high-video stream (high bitrate, and high-resolution video stream).

Parameters

  source | The video source type. See #VIDEO_SOURCE_TYPE.
  stats | Statistics of the local video stream. See LocalVideoStats.

## ◆ onRemoteVideoStats()

virtual void agora::rtc::IRtcEngineEventHandler::onRemoteVideoStats | ( | const RemoteVideoStats & | stats | ) |
| virtual

Reports the statistics of the video stream from each remote user/host.

The SDK triggers this callback once every two seconds for each remote user. If a channel has multiple users/hosts sending video streams, the SDK triggers this callback as many times.

Parameters

  stats | Statistics of the remote video stream. See RemoteVideoStats.

## ◆ onCameraReady()

virtual void agora::rtc::IRtcEngineEventHandler::onCameraReady | ( |  | ) |
| virtual

Occurs when the camera turns on and is ready to capture the video.

Deprecated:
  Use `LOCAL_VIDEO_STREAM_STATE_CAPTURING(1)` in onLocalVideoStateChanged instead. This callback indicates that the camera has been successfully turned on and you can start to capture video.

## ◆ onCameraFocusAreaChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onCameraFocusAreaChanged | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |
| virtual

Occurs when the camera focus area changes.

Note
  This method is for Andriod and iOS only.

Parameters

  x | The x coordinate of the changed camera focus area.
  y | The y coordinate of the changed camera focus area.
  width | The width of the changed camera focus area.
  height | The height of the changed camera focus area.

## ◆ onCameraExposureAreaChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onCameraExposureAreaChanged | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |
| virtual

Occurs when the camera exposure area changes.

Parameters

  x | The x coordinate of the changed camera exposure area.
  y | The y coordinate of the changed camera exposure area.
  width | The width of the changed camera exposure area.
  height | The height of the changed exposure area.

## ◆ onVideoStopped()

virtual void agora::rtc::IRtcEngineEventHandler::onVideoStopped | ( |  | ) |
| virtual

Occurs when the video stops playing.

Deprecated:
  Use `LOCAL_VIDEO_STREAM_STATE_STOPPED(0)` in the onLocalVideoStateChanged callback instead.

The app can use this callback to change the configuration of the view (for example, displaying other pictures in the view) after the video stops playing.

## ◆ onAudioMixingStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioMixingStateChanged | ( | AUDIO_MIXING_STATE_TYPE | state,
|  | AUDIO_MIXING_REASON_TYPE | reason
| ) |  |
| virtual

Occurs when the playback state of the music file changes.

This callback occurs when the playback state of the music file changes, and reports the current state and error code.

Parameters

  state | The playback state of the music file. See #AUDIO_MIXING_STATE_TYPE.
  reason | The reason for the change of the music file playback state. See #AUDIO_MIXING_REASON_TYPE.

## ◆ onRhythmPlayerStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onRhythmPlayerStateChanged | ( | RHYTHM_PLAYER_STATE_TYPE | state,
|  | RHYTHM_PLAYER_REASON | reason
| ) |  |
| virtual

Occurs when the state of the rhythm player changes. When you call the startRhythmPlayer method and the state of rhythm player changes, the SDK triggers this callback.

Parameters

  state | The state code. See #RHYTHM_PLAYER_STATE_TYPE.
  reason | The error code. See #RHYTHM_PLAYER_REASON.

## ◆ onConnectionLost()

virtual void agora::rtc::IRtcEngineEventHandler::onConnectionLost | ( |  | ) |
| virtual

Occurs when the SDK cannot reconnect to the server 10 seconds after its connection to the server is interrupted.

The SDK triggers this callback when it cannot connect to the server 10 seconds after calling `joinChannel`, regardless of whether it is in the channel or not. If the SDK fails to rejoin the channel 20 minutes after being disconnected from Agora's edge server, the SDK stops rejoining the channel.

## ◆ onConnectionInterrupted()

virtual void agora::rtc::IRtcEngineEventHandler::onConnectionInterrupted | ( |  | ) |
| virtual

Occurs when the connection between the SDK and the server is interrupted.

Deprecated:
  Use `onConnectionStateChanged` instead.

The SDK triggers this callback when it loses connection with the serer for more than 4 seconds after the connection is established. After triggering this callback, the SDK tries to reconnect to the server. If the reconnection fails within a certain period (10 seconds by default), the onConnectionLost() callback is triggered. If the SDK fails to rejoin the channel 20 minutes after being disconnected from Agora's edge server, the SDK stops rejoining the channel.

## ◆ onConnectionBanned()

virtual void agora::rtc::IRtcEngineEventHandler::onConnectionBanned | ( |  | ) |
| virtual

Occurs when your connection is banned by the Agora Server.

Deprecated:
  Use `onConnectionStateChanged` instead.

## ◆ onStreamMessage()

virtual void agora::rtc::IRtcEngineEventHandler::onStreamMessage | ( | uid_t | uid,
|  | int | streamId,
|  | const char * | data,
|  | size_t | length,
|  | uint64_t | sentTs
| ) |  |
| virtual

Occurs when the local user receives the data stream from the remote user.

The SDK triggers this callback when the user receives the data stream that another user sends by calling the sendStreamMessage method.

Parameters

  uid | ID of the user who sends the data stream.
  streamId | The ID of the stream data.
  data | The data stream.
  length | The length (byte) of the data stream.
  sentTs | The time when the data stream sent.

## ◆ onStreamMessageError()

virtual void agora::rtc::IRtcEngineEventHandler::onStreamMessageError | ( | uid_t | uid,
|  | int | streamId,
|  | int | code,
|  | int | missed,
|  | int | cached
| ) |  |
| virtual

Occurs when the local user does not receive the data stream from the remote user.

The SDK triggers this callback when the user fails to receive the data stream that another user sends by calling the sendStreamMessage method.

Parameters

  uid | ID of the user who sends the data stream.
  streamId | The ID of the stream data.
  code | The error code.
  missed | The number of lost messages.
  cached | The number of incoming cached messages when the data stream is interrupted.

## ◆ onRequestToken()

virtual void agora::rtc::IRtcEngineEventHandler::onRequestToken | ( |  | ) |
| virtual

Occurs when the token expires.

When the token expires during a call, the SDK triggers this callback to remind the app to renew the token.

Upon receiving this callback, generate a new token at your app server and call `joinChannel` to pass the new token to the SDK.

## ◆ onTokenPrivilegeWillExpire()

virtual void agora::rtc::IRtcEngineEventHandler::onTokenPrivilegeWillExpire | ( | const char * | token | ) |
| virtual

Occurs when the token will expire in 30 seconds.

When the token is about to expire in 30 seconds, the SDK triggers this callback to remind the app to renew the token.

Upon receiving this callback, generate a new token at your app server and call renewToken to pass the new Token to the SDK.

Parameters

  token | The token that will expire in 30 seconds.

## ◆ onLicenseValidationFailure()

virtual void agora::rtc::IRtcEngineEventHandler::onLicenseValidationFailure | ( | LICENSE_ERROR_TYPE | error | ) |
| virtual

Occurs when connection license verification fails.

You can know the reason accordding to error code

## ◆ onFirstLocalAudioFramePublished()

virtual void agora::rtc::IRtcEngineEventHandler::onFirstLocalAudioFramePublished | ( | int | elapsed | ) |
| virtual

Occurs when the first local audio frame is published.

The SDK triggers this callback under one of the following circumstances:

- The local client enables the audio module and calls `joinChannel` successfully.
- The local client calls `muteLocalAudioStream(true)` and `muteLocalAudioStream(false)` in sequence.
- The local client calls `disableAudio` and `enableAudio` in sequence.
- The local client calls `pushAudioFrame` to successfully push the audio frame to the SDK.

Parameters

  elapsed | The time elapsed (ms) from the local user calling `joinChannel` to the SDK triggers this callback.

## ◆ onFirstRemoteAudioDecoded()

virtual void agora::rtc::IRtcEngineEventHandler::onFirstRemoteAudioDecoded | ( | uid_t | uid,
|  | int | elapsed
| ) |  |
| virtual

Occurs when the SDK decodes the first remote audio frame for playback.

Deprecated:
  Use `onRemoteAudioStateChanged` instead. The SDK triggers this callback under one of the following circumstances:
  - The remote user joins the channel and sends the audio stream for the first time.
  - The remote user's audio is offline and then goes online to re-send audio. It means the local user cannot receive audio in 15 seconds. Reasons for such an interruption include:
    - The remote user leaves channel.
    - The remote user drops offline.
    - The remote user calls muteLocalAudioStream to stop sending the audio stream.
    - The remote user calls disableAudio to disable audio.

Parameters

  uid | User ID of the remote user sending the audio stream.
  elapsed | The time elapsed (ms) from the loca user calling `joinChannel` until this callback is triggered.

## ◆ onFirstRemoteAudioFrame()

virtual void agora::rtc::IRtcEngineEventHandler::onFirstRemoteAudioFrame | ( | uid_t | uid,
|  | int | elapsed
| ) |  |
| virtual

Occurs when the SDK receives the first audio frame from a specific remote user.

Deprecated:
  Use `onRemoteAudioStateChanged` instead.

Parameters

  uid | ID of the remote user.
  elapsed | The time elapsed (ms) from the loca user calling `joinChannel` until this callback is triggered.

## ◆ onLocalAudioStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onLocalAudioStateChanged | ( | LOCAL_AUDIO_STREAM_STATE | state,
|  | LOCAL_AUDIO_STREAM_REASON | reason
| ) |  |
| virtual

Occurs when the local audio state changes.

When the state of the local audio stream changes (including the state of the audio capture and encoding), the SDK triggers this callback to report the current state. This callback indicates the state of the local audio stream, and allows you to troubleshoot issues when audio exceptions occur.

Note
  When the state is `LOCAL_AUDIO_STREAM_STATE_FAILED(3)`, see the `error` parameter for details.

Parameters

  state | State of the local audio. See #LOCAL_AUDIO_STREAM_STATE.
  reason | The reason information of the local audio. See #LOCAL_AUDIO_STREAM_REASON.

## ◆ onRemoteAudioStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onRemoteAudioStateChanged | ( | uid_t | uid,
|  | REMOTE_AUDIO_STATE | state,
|  | REMOTE_AUDIO_STATE_REASON | reason,
|  | int | elapsed
| ) |  |
| virtual

Occurs when the remote audio state changes.

When the audio state of a remote user (in the voice/video call channel) or host (in the live streaming channel) changes, the SDK triggers this callback to report the current state of the remote audio stream.

Note
  This callback does not work properly when the number of users (in the voice/video call channel) or hosts (in the live streaming channel) in the channel exceeds 17.

Parameters

  uid | ID of the remote user whose audio state changes.
  state | State of the remote audio. See #REMOTE_AUDIO_STATE.
  reason | The reason of the remote audio state change. See #REMOTE_AUDIO_STATE_REASON.
  elapsed | Time elapsed (ms) from the local user calling the `joinChannel` method until the SDK triggers this callback.

## ◆ onActiveSpeaker()

virtual void agora::rtc::IRtcEngineEventHandler::onActiveSpeaker | ( | uid_t | uid | ) |
| virtual

Occurs when an active speaker is detected.

After a successful call of `enableAudioVolumeIndication`, the SDK continuously detects which remote user has the loudest volume. During the current period, the remote user, who is detected as the loudest for the most times, is the most active user.

When the number of users is no less than two and an active remote speaker exists, the SDK triggers this callback and reports the uid of the most active remote speaker.

- If the most active remote speaker is always the same user, the SDK triggers the `onActiveSpeaker` callback only once.
- If the most active remote speaker changes to another user, the SDK triggers this callback again and reports the uid of the new active remote speaker.

Parameters

  userId | The ID of the active speaker. A `uid` of 0 means the local user.

## ◆ onContentInspectResult()

virtual void agora::rtc::IRtcEngineEventHandler::onContentInspectResult | ( | media::CONTENT_INSPECT_RESULT | result | ) |
| virtual

Reports result of content inspection.

Parameters

  result | The result of content inspection: #CONTENT_INSPECT_RESULT.

## ◆ onSnapshotTaken()

virtual void agora::rtc::IRtcEngineEventHandler::onSnapshotTaken | ( | uid_t | uid,
|  | const char * | filePath,
|  | int | width,
|  | int | height,
|  | int | errCode
| ) |  |
| virtual

Reports the result of taking a video snapshot.

After a successful `takeSnapshot` method call, the SDK triggers this callback to report whether the snapshot is successfully taken, as well as the details for that snapshot.

Parameters

  uid | The user ID. A `uid` of 0 indicates the local user.
  filePath | The local path of the snapshot.
  width | The width (px) of the snapshot.
  height | The height (px) of the snapshot.
  errCode | The message that confirms success or gives the reason why the snapshot is not successfully taken: 0: Success. < 0: Failure. -1: The SDK fails to write data to a file or encode a JPEG image. -2: The SDK does not find the video stream of the specified user within one second after the `takeSnapshot` method call succeeds. -3: Calling the `takeSnapshot` method too frequently. Call the `takeSnapshot` method after receiving the `onSnapshotTaken` callback from the previous call.

## ◆ onClientRoleChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onClientRoleChanged | ( | CLIENT_ROLE_TYPE | oldRole,
|  | CLIENT_ROLE_TYPE | newRole,
|  | const ClientRoleOptions & | newRoleOptions
| ) |  |
| virtual

Occurs when the user role switches in the interactive live streaming.

Parameters

  oldRole | The old role of the user: #CLIENT_ROLE_TYPE.
  newRole | The new role of the user: #CLIENT_ROLE_TYPE.
  newRoleOptions | The client role options of the new role: #ClientRoleOptions.

## ◆ onClientRoleChangeFailed()

virtual void agora::rtc::IRtcEngineEventHandler::onClientRoleChangeFailed | ( | CLIENT_ROLE_CHANGE_FAILED_REASON | reason,
|  | CLIENT_ROLE_TYPE | currentRole
| ) |  |
| virtual

Occurs when the user role in a Live-Broadcast channel fails to switch, for example, from a broadcaster to an audience or vice versa.

Parameters

  reason | The reason for failing to change the client role: #CLIENT_ROLE_CHANGE_FAILED_REASON.
  currentRole | The current role of the user: #CLIENT_ROLE_TYPE.

## ◆ onAudioDeviceVolumeChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioDeviceVolumeChanged | ( | MEDIA_DEVICE_TYPE | deviceType,
|  | int | volume,
|  | bool | muted
| ) |  |
| virtual

Occurs when the audio device volume changes.

Parameters

  deviceType | The device type, see #MEDIA_DEVICE_TYPE
  volume | The volume of the audio device.
  muted | Whether the audio device is muted: true: The audio device is muted. false: The audio device is not muted.

## ◆ onRtmpStreamingStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onRtmpStreamingStateChanged | ( | const char * | url,
|  | RTMP_STREAM_PUBLISH_STATE | state,
|  | RTMP_STREAM_PUBLISH_REASON | reason
| ) |  |
| virtual

Occurs when the state of the RTMP streaming changes.

When the media push state changes, the SDK triggers this callback and reports the URL address and the current state of the media push. This callback indicates the state of the media push. When exceptions occur, you can troubleshoot issues by referring to the detailed error descriptions in the error code.

Parameters

  url | The URL address where the state of the media push changes.
  state | The current state of the media push: #RTMP_STREAM_PUBLISH_STATE.
  reason | The detailed error information for the media push: #RTMP_STREAM_PUBLISH_REASON.

## ◆ onRtmpStreamingEvent()

virtual void agora::rtc::IRtcEngineEventHandler::onRtmpStreamingEvent | ( | const char * | url,
|  | RTMP_STREAMING_EVENT | eventCode
| ) |  |
| virtual

Reports events during the media push.

Parameters

  url | The URL for media push.
  eventCode | The event code of media push. See RTMP_STREAMING_EVENT for details.

## ◆ onTranscodingUpdated()

virtual void agora::rtc::IRtcEngineEventHandler::onTranscodingUpdated | ( |  | ) |
| virtual

Occurs when the publisher's transcoding settings are updated.

When the `LiveTranscoding` class in setLiveTranscoding updates, the SDK triggers this callback to report the update information.

Note
  If you call the `setLiveTranscoding` method to set the `LiveTranscoding` class for the first time, the SDK does not trigger this callback.

## ◆ onAudioRoutingChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioRoutingChanged | ( | int | routing | ) |
| virtual

Occurs when the local audio route changes (for Android, iOS, and macOS only).

The SDK triggers this callback when the local audio route switches to an earpiece, speakerphone, headset, or Bluetooth device.

Parameters

  routing | The current audio output routing: -1: Default. 0: Headset. 1: Earpiece. 2: Headset with no microphone. 3: Speakerphone. 4: Loudspeaker. 5: Bluetooth headset.

## ◆ onChannelMediaRelayStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onChannelMediaRelayStateChanged | ( | int | state,
|  | int | code
| ) |  |
| virtual

Occurs when the state of the media stream relay changes.

The SDK reports the state of the current media relay and possible error messages in this callback.

Parameters

  state | The state code: `RELAY_STATE_IDLE(0)`: The SDK is initializing. `RELAY_STATE_CONNECTING(1)`: The SDK tries to relay the media stream to the destination channel. `RELAY_STATE_RUNNING(2)`: The SDK successfully relays the media stream to the destination channel. `RELAY_STATE_FAILURE(3)`: A failure occurs. See the details in `code`.
  code | The error code: `RELAY_OK(0)`: The state is normal. `RELAY_ERROR_SERVER_ERROR_RESPONSE(1)`: An error occurs in the server response. `RELAY_ERROR_SERVER_NO_RESPONSE(2)`: No server response. You can call the leaveChannel method to leave the channel. `RELAY_ERROR_NO_RESOURCE_AVAILABLE(3)`: The SDK fails to access the service, probably due to limited resources of the server. `RELAY_ERROR_FAILED_JOIN_SRC(4)`: Fails to send the relay request. `RELAY_ERROR_FAILED_JOIN_DEST(5)`: Fails to accept the relay request. `RELAY_ERROR_FAILED_PACKET_RECEIVED_FROM_SRC(6)`: The server fails to receive the media stream. `RELAY_ERROR_FAILED_PACKET_SENT_TO_DEST(7)`: The server fails to send the media stream. `RELAY_ERROR_SERVER_CONNECTION_LOST(8)`: The SDK disconnects from the server due to poor network connections. You can call the leaveChannel method to leave the channel. `RELAY_ERROR_INTERNAL_ERROR(9)`: An internal error occurs in the server. `RELAY_ERROR_SRC_TOKEN_EXPIRED(10)`: The token of the source channel has expired. `RELAY_ERROR_DEST_TOKEN_EXPIRED(11)`: The token of the destination channel has expired.

## ◆ onLocalPublishFallbackToAudioOnly()

virtual void agora::rtc::IRtcEngineEventHandler::onLocalPublishFallbackToAudioOnly | ( | bool | isFallbackOrRecover | ) |
| virtual

Occurs when the published media stream falls back to an audio-only stream due to poor network conditions or switches back to video stream after the network conditions improve.

If you call `setLocalPublishFallbackOption` and set `option` as `STREAM_FALLBACK_OPTION_AUDIO_ONLY(2)`, this callback is triggered when the locally published stream falls back to audio-only mode due to poor uplink conditions, or when the audio stream switches back to the video after the uplink network condition improves. Once the published stream falls back to audio only, the remote app receives the `onRemoteVideoStateChanged` callback.

Parameters

  isFallbackOrRecover | Whether the published stream fell back to audio-only or switched back to the video: `true`: The published stream fell back to audio-only due to poor network conditions. `false`: The published stream switched back to the video after the network conditions improved.

## ◆ onRemoteSubscribeFallbackToAudioOnly()

virtual void agora::rtc::IRtcEngineEventHandler::onRemoteSubscribeFallbackToAudioOnly | ( | uid_t | uid,
|  | bool | isFallbackOrRecover
| ) |  |
| virtual

Occurs when the remote media stream falls back to audio-only stream due to poor network conditions or switches back to video stream after the network conditions improve.

If you call `setRemoteSubscribeFallbackOption` and set `option` as `STREAM_FALLBACK_OPTION_AUDIO_ONLY(2)`, this callback is triggered when the remotely subscribed media stream falls back to audio-only mode due to poor downlink conditions, or when the remotely subscribed media stream switches back to the video after the downlink network condition improves.

Note
  Once the remote media stream is switched to the low stream due to poor network conditions, you can monitor the stream switch between a high and low stream in the `onRemoteVideoStats` callback.

Parameters

  uid | ID of the remote user sending the stream.
  isFallbackOrRecover | Whether the remote media stream fell back to audio-only or switched back to the video: `true`: The remote media stream fell back to audio-only due to poor network conditions. `false`: The remote media stream switched back to the video stream after the network conditions improved.

## ◆ onRemoteAudioTransportStats()

virtual void agora::rtc::IRtcEngineEventHandler::onRemoteAudioTransportStats | ( | uid_t | uid,
|  | unsigned short | delay,
|  | unsigned short | lost,
|  | unsigned short | rxKBitRate
| ) |  |
| virtual

Reports the transport-layer statistics of each remote audio stream.

Deprecated:
  Use `onRemoteAudioStats` instead.

This callback reports the transport-layer statistics, such as the packet loss rate and network time delay, once every two seconds after the local user receives an audio packet from a remote user. During a call, when the user receives the audio packet sent by the remote user/host, the callback is triggered every 2 seconds.

Parameters

  uid | ID of the remote user whose audio data packet is received.
  delay | The network time delay (ms) from the sender to the receiver.
  lost | The Packet loss rate (%) of the audio packet sent from the remote user.
  rxKBitRate | Received bitrate (Kbps) of the audio packet sent from the remote user.

## ◆ onRemoteVideoTransportStats()

virtual void agora::rtc::IRtcEngineEventHandler::onRemoteVideoTransportStats | ( | uid_t | uid,
|  | unsigned short | delay,
|  | unsigned short | lost,
|  | unsigned short | rxKBitRate
| ) |  |
| virtual

Reports the transport-layer statistics of each remote video stream.

Deprecated:
  Use `onRemoteVideoStats` instead.

This callback reports the transport-layer statistics, such as the packet loss rate and network time delay, once every two seconds after the local user receives a video packet from a remote user.

During a call, when the user receives the video packet sent by the remote user/host, the callback is triggered every 2 seconds.

Parameters

  uid | ID of the remote user whose video packet is received.
  delay | The network time delay (ms) from the remote user sending the video packet to the local user.
  lost | The packet loss rate (%) of the video packet sent from the remote user.
  rxKBitRate | The bitrate (Kbps) of the video packet sent from the remote user.

## ◆ onConnectionStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onConnectionStateChanged | ( | CONNECTION_STATE_TYPE | state,
|  | CONNECTION_CHANGED_REASON_TYPE | reason
| ) |  |
| virtual

Occurs when the network connection state changes.

When the network connection state changes, the SDK triggers this callback and reports the current connection state and the reason for the change.

Parameters

  state | The current connection state. See #CONNECTION_STATE_TYPE.
  reason | The reason for a connection state change. See #CONNECTION_CHANGED_REASON_TYPE.

## ◆ onWlAccMessage()

virtual void agora::rtc::IRtcEngineEventHandler::onWlAccMessage | ( | WLACC_MESSAGE_REASON | reason,
|  | WLACC_SUGGEST_ACTION | action,
|  | const char * | wlAccMsg
| ) |  |
| virtual

Occurs when the WIFI message need be sent to the user.

Parameters

  reason | The reason of notifying the user of a message.
  action | Suggest an action for the user.
  wlAccMsg | The message content of notifying the user.

## ◆ onWlAccStats()

virtual void agora::rtc::IRtcEngineEventHandler::onWlAccStats | ( | const WlAccStats & | currentStats,
|  | const WlAccStats & | averageStats
| ) |  |
| virtual

Occurs when SDK statistics wifi acceleration optimization effect.

Parameters

  currentStats | Instantaneous value of optimization effect.
  averageStats | Average value of cumulative optimization effect.

## ◆ onNetworkTypeChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onNetworkTypeChanged | ( | NETWORK_TYPE | type | ) |
| virtual

Occurs when the local network type changes.

This callback occurs when the connection state of the local user changes. You can get the connection state and reason for the state change in this callback. When the network connection is interrupted, this callback indicates whether the interruption is caused by a network type change or poor network conditions.

Parameters

  type | The type of the local network connection. See #NETWORK_TYPE.

## ◆ onEncryptionError()

virtual void agora::rtc::IRtcEngineEventHandler::onEncryptionError | ( | ENCRYPTION_ERROR_TYPE | errorType | ) |
| virtual

Reports the built-in encryption errors.

When encryption is enabled by calling `enableEncryption`, the SDK triggers this callback if an error occurs in encryption or decryption on the sender or the receiver side.

Parameters

  errorType | The error type. See #ENCRYPTION_ERROR_TYPE.

## ◆ onPermissionError()

virtual void agora::rtc::IRtcEngineEventHandler::onPermissionError | ( | PERMISSION_TYPE | permissionType | ) |
| virtual

Occurs when the SDK cannot get the device permission.

When the SDK fails to get the device permission, the SDK triggers this callback to report which device permission cannot be got.

Note
  This method is for Android and iOS only.

Parameters

  permissionType | The type of the device permission. See #PERMISSION_TYPE.

## ◆ onLocalUserRegistered()

virtual void agora::rtc::IRtcEngineEventHandler::onLocalUserRegistered | ( | uid_t | uid,
|  | const char * | userAccount
| ) |  |
| virtual

Occurs when the local user registers a user account.

After the local user successfully calls `registerLocalUserAccount` to register the user account or calls `joinChannelWithUserAccount` to join a channel, the SDK triggers the callback and informs the local user's UID and User Account.

Parameters

  uid | The ID of the local user.
  userAccount | The user account of the local user.

## ◆ onUserInfoUpdated()

virtual void agora::rtc::IRtcEngineEventHandler::onUserInfoUpdated | ( | uid_t | uid,
|  | const UserInfo & | info
| ) |  |
| virtual

Occurs when the SDK gets the user ID and user account of the remote user.

After a remote user joins the channel, the SDK gets the UID and user account of the remote user, caches them in a mapping table object (`userInfo`), and triggers this callback on the local client.

Parameters

  uid | The ID of the remote user.
  info | The `UserInfo` object that contains the user ID and user account of the remote user.

## ◆ onUserAccountUpdated()

virtual void agora::rtc::IRtcEngineEventHandler::onUserAccountUpdated | ( | uid_t | uid,
|  | const char * | userAccount
| ) |  |
| virtual

Occurs when the user account is updated.

Parameters

  uid | The user ID.
  userAccount | The user account.

## ◆ onVideoRenderingTracingResult()

virtual void agora::rtc::IRtcEngineEventHandler::onVideoRenderingTracingResult | ( | uid_t | uid,
|  | MEDIA_TRACE_EVENT | currentEvent,
|  | VideoRenderingTracingInfo | tracingInfo
| ) |  |
| virtual

Reports the tracing result of video rendering event of the user.

Parameters

  uid | The user ID.
  currentEvent | The current event of the tracing result: #MEDIA_TRACE_EVENT.
  tracingInfo | The tracing result: #VideoRenderingTracingInfo.

## ◆ onLocalVideoTranscoderError()

virtual void agora::rtc::IRtcEngineEventHandler::onLocalVideoTranscoderError | ( | const TranscodingVideoStream & | stream,
|  | VIDEO_TRANSCODER_ERROR | error
| ) |  |
| virtual

Occurs when local video transcoder stream has an error.

Parameters

  stream | Stream type of TranscodingVideoStream.
  error | Error code of VIDEO_TRANSCODER_ERROR.

## ◆ onUploadLogResult()

virtual void agora::rtc::IRtcEngineEventHandler::onUploadLogResult | ( | const char * | requestId,
|  | bool | success,
|  | UPLOAD_ERROR_REASON | reason
| ) |  |
| virtual

Reports the user log upload result

Parameters

  requestId | RequestId of the upload
  success | Is upload success
  reason | Reason of the upload, 0: OK, 1 Network Error, 2 Server Error.

## ◆ onAudioSubscribeStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioSubscribeStateChanged | ( | const char * | channel,
|  | uid_t | uid,
|  | STREAM_SUBSCRIBE_STATE | oldState,
|  | STREAM_SUBSCRIBE_STATE | newState,
|  | int | elapseSinceLastState
| ) |  |
| virtual

Occurs when the audio subscribing state changes.

Parameters

  channel | The name of the channel.
  uid | The ID of the remote user.
  oldState | The previous subscribing status: #STREAM_SUBSCRIBE_STATE.
  newState | The current subscribing status: #STREAM_SUBSCRIBE_STATE.
  elapseSinceLastState | The time elapsed (ms) from the previous state to the current state.

## ◆ onVideoSubscribeStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onVideoSubscribeStateChanged | ( | const char * | channel,
|  | uid_t | uid,
|  | STREAM_SUBSCRIBE_STATE | oldState,
|  | STREAM_SUBSCRIBE_STATE | newState,
|  | int | elapseSinceLastState
| ) |  |
| virtual

Occurs when the video subscribing state changes.

Parameters

  channel | The name of the channel.
  uid | The ID of the remote user.
  oldState | The previous subscribing status: #STREAM_SUBSCRIBE_STATE.
  newState | The current subscribing status: #STREAM_SUBSCRIBE_STATE.
  elapseSinceLastState | The time elapsed (ms) from the previous state to the current state.

## ◆ onAudioPublishStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioPublishStateChanged | ( | const char * | channel,
|  | STREAM_PUBLISH_STATE | oldState,
|  | STREAM_PUBLISH_STATE | newState,
|  | int | elapseSinceLastState
| ) |  |
| virtual

Occurs when the audio publishing state changes.

Parameters

  channel | The name of the channel.
  oldState | The previous publishing state: #STREAM_PUBLISH_STATE.
  newState | The current publishing state: #STREAM_PUBLISH_STATE.
  elapseSinceLastState | The time elapsed (ms) from the previous state to the current state.

## ◆ onVideoPublishStateChanged()

virtual void agora::rtc::IRtcEngineEventHandler::onVideoPublishStateChanged | ( | VIDEO_SOURCE_TYPE | source,
|  | const char * | channel,
|  | STREAM_PUBLISH_STATE | oldState,
|  | STREAM_PUBLISH_STATE | newState,
|  | int | elapseSinceLastState
| ) |  |
| virtual

Occurs when the video publishing state changes.

Parameters

  source | The video source type.
  channel | The name of the channel.
  oldState | The previous publishing state: #STREAM_PUBLISH_STATE.
  newState | The current publishing state: #STREAM_PUBLISH_STATE.
  elapseSinceLastState | The time elapsed (ms) from the previous state to the current state.

## ◆ onTranscodedStreamLayoutInfo()

virtual void agora::rtc::IRtcEngineEventHandler::onTranscodedStreamLayoutInfo | ( | uid_t | uid,
|  | int | width,
|  | int | height,
|  | int | layoutCount,
|  | const VideoLayout * | layoutlist
| ) |  |
| virtual

Occurs when receive a video transcoder stream which has video layout info.

Parameters

  uid | user id of the transcoded stream.
  width | width of the transcoded stream.
  height | height of the transcoded stream.
  layoutCount | count of layout info in the transcoded stream.
  layoutlist | video layout info list of the transcoded stream.

## ◆ onAudioMetadataReceived()

virtual void agora::rtc::IRtcEngineEventHandler::onAudioMetadataReceived | ( | uid_t | uid,
|  | const char * | metadata,
|  | size_t | length
| ) |  |
| virtual

Occurs when the SDK receives audio metadata.

Since
  v4.3.1

Parameters

  uid | ID of the remote user.
  metadata | The pointer of metadata
  length | Size of metadata @technical preview

## ◆ onExtensionEventWithContext()

virtual void agora::rtc::IRtcEngineEventHandler::onExtensionEventWithContext | ( | const ExtensionContext & | context,
|  | const char * | key,
|  | const char * | value
| ) |  |
| virtual

The event callback of the extension.

To listen for events while the extension is running, you need to register this callback.

Parameters

  context | The context of the extension.
  key | The key of the extension.
  value | The value of the extension key.

## ◆ onExtensionStartedWithContext()

virtual void agora::rtc::IRtcEngineEventHandler::onExtensionStartedWithContext | ( | const ExtensionContext & | context | ) |
| virtual

Occurs when the extension is enabled.

After a successful creation of filter , the extension triggers this callback.

Parameters

  context | The context of the extension.

## ◆ onExtensionStoppedWithContext()

virtual void agora::rtc::IRtcEngineEventHandler::onExtensionStoppedWithContext | ( | const ExtensionContext & | context | ) |
| virtual

Occurs when the extension is disabled.

After a successful destroy filter, the extension triggers this callback.

Parameters

  context | The context of the extension.

## ◆ onExtensionErrorWithContext()

virtual void agora::rtc::IRtcEngineEventHandler::onExtensionErrorWithContext | ( | const ExtensionContext & | context,
|  | int | error,
|  | const char * | message
| ) |  |
| virtual

Occurs when the extension runs incorrectly.

When the extension runs in error, the extension triggers this callback and reports the error code and reason.

Parameters

  context | The context of the extension.
  error | The error code. For details, see the extension documentation provided by the extension provider.
  message | The error message. For details, see the extension documentation provided by the extension provider.

## ◆ onSetRtmFlagResult()

virtual void agora::rtc::IRtcEngineEventHandler::onSetRtmFlagResult | ( | int | code | ) |
| virtual

Occurs when the SDK receives RTM setting change response.

@technical preview

Parameters

  code | The error code.